#include <stdio.h>
#include <wiringPi.h>
#include "switch.h"

static const int pin_sw_d  = 12;
static const int pin_sw_l  = 25;
static const int pin_sw_r  = 26;

int switch_open(){
	// GPIOデバイスのオープン
	if(wiringPiSetupGpio() != 0){
		printf("failed to open GPIO\n");
		return -1;
	}else{
		// ピン設定
		pinMode(pin_sw_d, INPUT);
		pinMode(pin_sw_l, INPUT);
		pinMode(pin_sw_r, INPUT);
		pullUpDnControl(pin_sw_d, PUD_UP);
		pullUpDnControl(pin_sw_l, PUD_UP);
		pullUpDnControl(pin_sw_r, PUD_UP);

		printf("GPIO opened\n");
		return 0;
	}
}

void switch_get(int *sw_d, int *sw_l, int *sw_r){
	*sw_d = digitalRead(pin_sw_d);
	*sw_l = digitalRead(pin_sw_l);
	*sw_r = digitalRead(pin_sw_r);
}
