#include <stdio.h>
#include "arduino.h"
#include "request.h"
#include <wiringPi.h>
#include "switch.h"
#include <unistd.h>
#include "run.h"
#include "display.h"

void line();
void marker();
void pato();
void stop_detect();

int state;
run_state_t run_state;
int speed;
int dist;

int main(){
	int num,i;
	int sw1,sw2,sw3;
	int speed,dist;
	char buf[256];

	if(arduino_open() != 0) return -1;
	if(switch_open() != 0) return -1;

	pinMode(18, OUTPUT);

	printf("走行テスト(正方形):1 スイッチテスト:2 単体テスト:3 走行テストv2:4 走行テストv3:5 走行テストv4:6\n");
	fgets(buf, sizeof(buf), stdin);
	sscanf(buf, "%d", &num);
	switch (num) {
		case 1:
			printf("ライン引きon:1 ライン引きoff:0\n");
			fgets(buf, sizeof(buf), stdin);
			sscanf(buf, "%d", &state);
			pato(1);
			usleep(1000*1000);
			for(i = 0;i < 4;i++){
				if(state == 1){
					line(1);
				}
				printf("straight%d\n",i);
				request_set_runmode(STR,30,100);
				usleep(4000*1000);
				line(0);
				printf("marker%d\n",i);
				marker();
				printf("rotate%d\n",i);
				request_set_runmode(ROT,90,90);
				usleep(1500*1000);
			}
			usleep(1000*1000);
			pato(0);
			break;
		case 2:
			printf("全押しでbreak\n");
			usleep(1000*1000);
			while(1){
				switch_get(&sw1, &sw2, &sw3);
				printf("左：%d, 決定：%d, 右：%d\n", sw2, sw1, sw3);
				usleep(100 * 1000);
				if(sw1 == 0 && sw2 == 0 && sw3 == 0){
					printf("break\n");
					break;
				}
			}
			break;
		case 3:
			printf("str:1 rot:2 line:3 marker:4\n");
			fgets(buf, sizeof(buf), stdin);
			sscanf(buf, "%d", &state);
			switch(state){
				case 1:
					printf("speed? [cm/s]\n");
					fgets(buf, sizeof(buf), stdin);
					sscanf(buf, "%d", &speed);

					printf("dist? [cm]\n");
					fgets(buf, sizeof(buf), stdin);
					sscanf(buf, "%d", &dist);

					request_set_runmode(STR, speed, dist);
					break;
				case 2:
					printf("speed? [deg/s]\n");
					fgets(buf, sizeof(buf), stdin);
					sscanf(buf, "%d", &speed);

					printf("angle? [deg]\n");
					fgets(buf, sizeof(buf), stdin);
					sscanf(buf, "%d", &dist);

					request_set_runmode(ROT, speed, dist);
					break;
				case 3:
					request_set_line(80);
					usleep(3000*1000);
					request_set_line(0);
					break;
				case 4:
					request_set_marker(80);
					usleep(3000*1000);
					request_set_marker(0);
					break;
			}
			break;
		case 4:
			printf("speed?\n");
			fgets(buf, sizeof(buf), stdin);
			sscanf(buf, "%d", &speed);
			request_set_line(20);
			request_set_runmode(STR, speed, 50);
			stop_detect();
			request_set_line(0);
			break;
		case 5:
			printf("speed?\n");
			fgets(buf, sizeof(buf), stdin);
			sscanf(buf, "%d", &speed);
			//display_wait();
			//request_set_line(20);
			request_set_runmode(STR, speed, 90);
			stop_detect();
			for(int i = 0; i < 4; i++){
				//request_set_line(20);
				request_set_runmode(STR, speed, 90);
				stop_detect();
				//request_set_line(0);
				request_set_runmode(STR, 20, 20);
				stop_detect();
				request_set_runmode(ROT, speed, 88);
				stop_detect();
				request_set_runmode(STR, 20, -20);
				stop_detect();
				//request_set_line(20);
				request_set_runmode(STR, speed, 60);
				stop_detect();
				//request_set_line(0);
				request_set_marker(91);
				usleep(3000*1000);
				request_set_runmode(STR, speed, -10);
				stop_detect();
				request_set_runmode(STR, 20, 10);
				stop_detect();
			}
			request_set_runmode(STR, speed, 30);
			stop_detect();
			request_set_runmode(ROT, speed, 88);
			stop_detect();
			request_set_runmode(STR, speed, 75);
			stop_detect();
			//display_send('f');
			break;
		case 6:
			request_set_line(20);
			request_set_runmode(STR, speed, 50);
			stop_detect();
			request_set_line(0);
			request_set_runmode(ROT, speed, 97);
			stop_detect();
			request_set_runmode(STR, 20, -20);
			stop_detect();
			request_set_line(20);
			request_set_runmode(STR, speed, 50);
			stop_detect();
			request_set_line(0);
			break;
	}

}

void line(int line_set){
	if(state == 1){
		if(line_set == 1){
			request_set_line(50);
		}else{
			request_set_line(0);
		}
	}else{
		request_set_line(0);
	}
}

void marker(){
	request_set_marker(95);
	usleep(3500*1000);
}

void pato(int pat_set){
	if(pat_set == 1){
		digitalWrite(18,1);
	}else{
		digitalWrite(18,0);
	}
}
